var inStr = ""; // Строка имитирующая входную ленту (данные из формы)
var erStr = ""; // Строка с сообщением о результатах разбора
var i = 10;  // Текущее положение входной головки
var erFlag = -1; // Флаг, фиксирующий наличие ошибок в середине правила

// Функция, реализующая чтение символов в буфер из поля формы.
function GetLine() {
    var bracketsInput = document.getElementById("bracketsInput");
    inStr = bracketsInput.value + ".";
}

// Функция, реализующая распознавание нетерминала B.
function B() {
    if(inStr[i] == "(") {
        i++;
        if(B()) {
            if(inStr[i] == ")") {
                i++;
                if(B()) {
                    // Если последний нетерминал корректен, то корректно и все правило.
                    return true; 
                }
                else { // Ошибка в нетерминале B
                    erFlag++;
                    erStr += "<br>Position " + i + ", " + "Error 1: Incorrect last B!";
                    return false;
                }
            }
            else { // Это не ')'
                erFlag++;
                erStr += "<br>Position " + i + ", " + "Error 2: I want \')\'!";
                return false;
            }
        }
        else {
            erFlag++;
            erStr += "<br>Position " + i + ", " + "Error 3: Incorrect first B!";
            return false;
        }
    } else           // Смотрим другую альтернативу:
        return true; // Пустая цепочка допустима
}

// Функция, реализующая распознавание нетерминала S.
function S() {
    if(inStr[i] == "(") {
        i++;
        if(B()) {
            if(inStr[i] == ")") {
                i++;
                if(B()) {
                    if(inStr[i] == ".") {
                        return true; // за последним нетерминалом - конец
                    } 
                    else { // Там ничего не должно быть
                        erFlag++;
                        erStr += "<br>Position " + i + ", " 
                              + "Error 4: I want string end after last right bracket!";
                        return false;
                    }
                } else {
                    erFlag++;
                    erStr += "<br>Position " + i + ", " + "Error 4: Incorrect last B!";
                    return false;
                }
            } else {
                erFlag++;
                erStr += "<br>Position " + i + ", " + "Error 5: I want \')\'!";
                return false;
            }
        } else {
            erFlag++;
            erStr += "<br>Position " + i + ", " + "Error 6: Incorrect first B!";
            return false;
        }
    }
    return false; // Первый символ цепочки некорректен
                  // что это ошибка, лучше определить снаружи
}

function Parser() {
    // Начальная инициализация.
    erFlag = 0;
    i = 0;

    // Процесс пошел!
    if(S()) { 
        return true; // Все прошло нормально
    }
    else {
        if(erFlag) {
            erStr += "<br>Position " + i + ", " + "Error 7: Internal Error!";
        }
        else {
            erStr = "<br>Position " + i + ", " + "Error 8: Incorrect first symbol of S!";
        }
        return false; // Есть ошибки
    }
}

// Вспомогательная функция, осуществляющая повторение строки ch k раз.
function Repeat(k, ch) {
    var s = "";
    for(i = 0; i < k; i++) {
        s += ch;
    }
    return s;
}

// event handlers

// Функция запускающая парсер и осуществляющая вывод результатов разбора
function handleParseButton() {

    // Очистка буфера сообщений об ошибках
    erStr = "";
    // Чтение строки из формы в буфер для разбора
    GetLine();
    
    var rezStr = "";
    // Здесь начинается разбор принятой строки.
    if(Parser()) {
        rezStr = "+++++ OK! +++++";
    }
    else {
        rezStr = "----- Fatal error (look upper error message)! -----";
    }

    // Вывод разобранной строки и значения позиции входой головки.
    var mesStr = "Line: " + inStr;
    var strCursor = " Pos: " + Repeat(i, "-") + "^" + "  i = " + i;
    
    // Вывод сообщения о результатах разбора
    var messageField = document.getElementById("messageField");
    messageField.innerHTML = rezStr;

    // Вывод разобранного скобочного выражения
    var bracketsField = document.getElementById("bracketsField");
    bracketsField.innerHTML = mesStr.substr(0, mesStr.length-1);

    // Вывод позиции входной головки в момент окончания разбора
    var cursorField = document.getElementById("cursorField");
    cursorField.innerHTML = strCursor;

    // Вывод накопленных сообщений об ошибках к моменту окончания разбора
    var errorsField = document.getElementById("errorsField");
    errorsField.innerHTML = erStr;

}

function handleKeyPress(e) {
    var parseButton = document.getElementById("parseButton");

    // in IE9 and earlier, the event object doesn't get passed
    // to the event handler correctly, so we use window.event instead.
    e = e || window.event;
    
    if (e.keyCode === 13) {
        parseButton.click();
        return false;
    }
}


// init - called when the page has completed loading
window.onload = init;

function init() {
    // Parse button onclick handler
    var parseButton = document.getElementById("parseButton");
    parseButton.onclick = handleParseButton;

    // handle "return" key press
    var bracketsInput = document.getElementById("bracketsInput");
    bracketsInput.onkeypress = handleKeyPress;

    // place the ships on the game board
    //model.generateShipLocations();
}


